(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (fixnum) (not safe))
  (define std/sort#sort
    (lambda (_seq2149_ _elt<2151_)
      (if (procedure? _elt<2151_)
          '#!void
          (error '"Expected procedure" _elt<2151_))
      (if (null? _seq2149_)
          _seq2149_
          (if (pair? _seq2149_)
              (std/sort#list-merge-sort _seq2149_ _elt<2151_)
              (if (vector? _seq2149_)
                  (std/sort#heap-sort _seq2149_ _elt<2151_)
                  (error '"Expected list or vector" _seq2149_))))))
  (define std/sort#sort!
    (lambda (_seq2144_ _elt<2146_)
      (if (procedure? _elt<2146_)
          '#!void
          (error '"Expected procedure" _elt<2146_))
      (if (null? _seq2144_)
          _seq2144_
          (if (pair? _seq2144_)
              (std/sort#list-merge-sort! _seq2144_ _elt<2146_)
              (if (vector? _seq2144_)
                  (std/sort#vector-heap-sort! _seq2144_ _elt<2146_)
                  (error '"Expected list or vector" _seq2144_))))))
  (define std/sort#stable-sort
    (lambda (_seq2139_ _elt<2141_)
      (if (procedure? _elt<2141_)
          '#!void
          (error '"Expected procedure" _elt<2141_))
      (if (null? _seq2139_)
          _seq2139_
          (if (pair? _seq2139_)
              (std/sort#list-merge-sort _seq2139_ _elt<2141_)
              (if (vector? _seq2139_)
                  (std/sort#vector-merge-sort _seq2139_ _elt<2141_)
                  (error '"Expected list or vector" _seq2139_))))))
  (define std/sort#stable-sort!
    (lambda (_seq2134_ _elt<2136_)
      (if (procedure? _elt<2136_)
          '#!void
          (error '"Expected procedure" _elt<2136_))
      (if (null? _seq2134_)
          _seq2134_
          (if (pair? _seq2134_)
              (std/sort#list-merge-sort! _seq2134_ _elt<2136_)
              (if (vector? _seq2134_)
                  (std/sort#vector-merge-sort! _seq2134_ _elt<2136_)
                  (error '"Expected list or vector" _seq2134_))))))
  (define std/sort#vector-copy!
    (lambda (_target2129_ _src2130_ _start2131_ _end2132_)
      (subvector-move! _src2130_ _start2131_ _end2132_ _target2129_ '0)))
  (define std/sort#vector-merge-sort!
    (lambda (_v2126_ _elt<2127_)
      (std/sort#%vector-merge-sort!
       _v2126_
       _elt<2127_
       '0
       (vector-length _v2126_)
       (vector-copy _v2126_))
      _v2126_))
  (define std/sort#vector-merge-sort
    (lambda (_v2123_ _elt<2124_)
      (std/sort#vector-merge-sort! (vector-copy _v2123_) _elt<2124_)))
  (define std/sort#vector-heap-sort!
    (lambda (_v2120_ _elt<2121_)
      (std/sort#heap-sort! _v2120_ _elt<2121_)
      _v2120_))
  (define std/sort#parse-vector-start+end
    (lambda (_proc2098_ _v2099_ _args2100_)
      (let ((_vlen2102_ (vector-length _v2099_)))
        (if (pair? _args2100_)
            (let ((_start2104_ (car _args2100_)) (_args2105_ (cdr _args2100_)))
              (if (or (not (integer? _start2104_)) (< _start2104_ '0))
                  (error '"Illegal subvector START spec"
                         _proc2098_
                         _start2104_
                         _v2099_)
                  (call-with-values
                   (lambda ()
                     (if (pair? _args2105_)
                         (let ((_end2111_ (car _args2105_))
                               (_args2112_ (cdr _args2105_)))
                           (if (or (not (integer? _end2111_))
                                   (< _vlen2102_ _end2111_))
                               (error '"Illegal subvector END spec"
                                      _proc2098_
                                      _end2111_
                                      _v2099_)
                               (values _end2111_ _args2112_)))
                         (values _vlen2102_ _args2105_)))
                   (lambda (_end2117_ _args2118_)
                     (if (<= _start2104_ _end2117_)
                         (values _start2104_ _end2117_ _args2118_)
                         (error '"Illegal subvector START/END spec"
                                _proc2098_
                                _start2104_
                                _end2117_
                                _v2099_))))))
            (values '0 (vector-length _v2099_) '())))))
  (define std/sort#parse-vector-final-start+end
    (lambda (_proc2089_ _v2090_ _args2091_)
      (call-with-values
       (lambda ()
         (std/sort#parse-vector-start+end _proc2089_ _v2090_ _args2091_))
       (lambda (_start2094_ _end2095_ _rest2096_)
         (if (pair? _rest2096_)
             (error '"Extra arguments to procedure" _proc2089_ _rest2096_)
             (values _start2094_ _end2095_))))))
  (define std/sort#list-merge-sort
    (lambda (_lis2009_ _elt<2010_)
      (letrec ((_getrun2012_
                (lambda (_lis2079_)
                  (let _lp2081_ ((_xs2083_ (cdr _lis2079_))
                                 (_prev2084_ (car _lis2079_))
                                 (_i2085_ '1))
                    (if (pair? _xs2083_)
                        (let ((_x2087_ (car _xs2083_)))
                          (if (_elt<2010_ _x2087_ _prev2084_)
                              (values _i2085_ _xs2083_)
                              (_lp2081_
                               (cdr _xs2083_)
                               _x2087_
                               (+ _i2085_ '1))))
                        (values _i2085_ _xs2083_)))))
               (_cmerge2013_
                (lambda (_a2057_ _la2058_ _b2059_ _lb2060_)
                  (let _recur2062_ ((_x2064_ (car _a2057_))
                                    (_a2065_ _a2057_)
                                    (_la2066_ _la2058_)
                                    (_y2067_ (car _b2059_))
                                    (_b2068_ _b2059_)
                                    (_lb2069_ _lb2060_))
                    (if (_elt<2010_ _y2067_ _x2064_)
                        (cons _y2067_
                              (let ((_lb2071_ (- _lb2069_ '1)))
                                (if (= _lb2071_ '0)
                                    _a2065_
                                    (let ((_b2073_ (cdr _b2068_)))
                                      (_recur2062_
                                       _x2064_
                                       _a2065_
                                       _la2066_
                                       (car _b2073_)
                                       _b2073_
                                       _lb2071_)))))
                        (cons _x2064_
                              (let ((_la2075_ (- _la2066_ '1)))
                                (if (= _la2075_ '0)
                                    _b2068_
                                    (let ((_a2077_ (cdr _a2065_)))
                                      (_recur2062_
                                       (car _a2077_)
                                       _a2077_
                                       _la2075_
                                       _y2067_
                                       _b2068_
                                       _lb2069_)))))))))
               (_grow2014_
                (lambda (_s2031_ _ls2032_ _ls22033_ _u2034_ _lw2035_)
                  (if (or (<= _lw2035_ _ls2032_) (not (pair? _u2034_)))
                      (values _s2031_ _ls2032_ _u2034_)
                      (let ((_ls22046_
                             (let _lp2040_ ((_ls22042_ _ls22033_))
                               (let ((_ls2*22044_ (+ _ls22042_ _ls22042_)))
                                 (if (<= _ls2*22044_ _ls2032_)
                                     (_lp2040_ _ls2*22044_)
                                     _ls22042_)))))
                        (call-with-values
                         (lambda () (_getrun2012_ _u2034_))
                         (lambda (_lr2049_ _u22050_)
                           (call-with-values
                            (lambda ()
                              (_grow2014_
                               _u2034_
                               _lr2049_
                               '1
                               _u22050_
                               _ls22046_))
                            (lambda (_t2053_ _lt2054_ _u32055_)
                              (_grow2014_
                               (_cmerge2013_ _s2031_ _ls2032_ _t2053_ _lt2054_)
                               (+ _ls2032_ _lt2054_)
                               (+ _ls22046_ _ls22046_)
                               _u32055_
                               _lw2035_)))))))))
               (_first2015_
                (lambda (_lis2028_ _i2029_)
                  (if (= '0 _i2029_)
                      '()
                      (cons (car _lis2028_)
                            (_first2015_ (cdr _lis2028_) (- _i2029_ '1)))))))
        (if (not (pair? _lis2009_))
            '()
            (call-with-values
             (lambda () (_getrun2012_ _lis2009_))
             (lambda (_lr2018_ _tail2019_)
               (let ((_infinity2021_ '16777216))
                 (call-with-values
                  (lambda ()
                    (_grow2014_
                     _lis2009_
                     _lr2018_
                     '1
                     _tail2019_
                     _infinity2021_))
                  (lambda (_a2024_ _la2025_ _v2026_)
                    (_first2015_ _a2024_ _la2025_))))))))))
  (define std/sort#list-merge-sort!
    (lambda (_lis1909_ _elt<1910_)
      (letrec ((_getrun1912_
                (lambda (_lis1998_)
                  (let _lp2000_ ((_lis2002_ _lis1998_)
                                 (_x2003_ (car _lis1998_))
                                 (_i2004_ '1)
                                 (_next2005_ (cdr _lis1998_)))
                    (if (pair? _next2005_)
                        (let ((_y2007_ (car _next2005_)))
                          (if (_elt<1910_ _y2007_ _x2003_)
                              (values _i2004_ _lis2002_ _next2005_)
                              (_lp2000_
                               _next2005_
                               _y2007_
                               (+ _i2004_ '1)
                               (cdr _next2005_))))
                        (values _i2004_ _lis2002_ _next2005_)))))
               (_merge!1913_
                (lambda (_a1959_ _enda1960_ _b1961_ _endb1962_)
                  (letrec ((_scan-a1964_
                            (lambda (_prev1968_
                                     _x1969_
                                     _a1970_
                                     _y1971_
                                     _b1972_)
                              (if (_elt<1910_ _y1971_ _x1969_)
                                  (begin
                                    (set-cdr! _prev1968_ _b1972_)
                                    (let ((_next-b1974_ (cdr _b1972_)))
                                      (if (eq? _b1972_ _endb1962_)
                                          (begin
                                            (set-cdr! _b1972_ _a1970_)
                                            _enda1960_)
                                          (_scan-b1965_
                                           _b1972_
                                           _x1969_
                                           _a1970_
                                           (car _next-b1974_)
                                           _next-b1974_))))
                                  (if (eq? _a1970_ _enda1960_)
                                      (begin
                                        (_maybe-set-cdr!1966_ _a1970_ _b1972_)
                                        _endb1962_)
                                      (let ((_next-a1976_ (cdr _a1970_)))
                                        (_scan-a1964_
                                         _a1970_
                                         (car _next-a1976_)
                                         _next-a1976_
                                         _y1971_
                                         _b1972_))))))
                           (_scan-b1965_
                            (lambda (_prev1978_
                                     _x1979_
                                     _a1980_
                                     _y1981_
                                     _b1982_)
                              (if (_elt<1910_ _y1981_ _x1979_)
                                  (if (eq? _b1982_ _endb1962_)
                                      (begin
                                        (set-cdr! _b1982_ _a1980_)
                                        _enda1960_)
                                      (let ((_next-b1984_ (cdr _b1982_)))
                                        (_scan-b1965_
                                         _b1982_
                                         _x1979_
                                         _a1980_
                                         (car _next-b1984_)
                                         _next-b1984_)))
                                  (begin
                                    (set-cdr! _prev1978_ _a1980_)
                                    (if (eq? _a1980_ _enda1960_)
                                        (begin
                                          (_maybe-set-cdr!1966_
                                           _a1980_
                                           _b1982_)
                                          _endb1962_)
                                        (let ((_next-a1986_ (cdr _a1980_)))
                                          (_scan-a1964_
                                           _a1980_
                                           (car _next-a1986_)
                                           _next-a1986_
                                           _y1981_
                                           _b1982_)))))))
                           (_maybe-set-cdr!1966_
                            (lambda (_pair1988_ _val1989_)
                              (if (not (eq? (cdr _pair1988_) _val1989_))
                                  (set-cdr! _pair1988_ _val1989_)
                                  '#!void))))
                    (let ((_x1991_ (car _a1959_)) (_y1992_ (car _b1961_)))
                      (if (_elt<1910_ _y1992_ _x1991_)
                          (values _b1961_
                                  (if (eq? _b1961_ _endb1962_)
                                      (begin
                                        (set-cdr! _b1961_ _a1959_)
                                        _enda1960_)
                                      (let ((_next-b1994_ (cdr _b1961_)))
                                        (_scan-b1965_
                                         _b1961_
                                         _x1991_
                                         _a1959_
                                         (car _next-b1994_)
                                         _next-b1994_))))
                          (values _a1959_
                                  (if (eq? _a1959_ _enda1960_)
                                      (begin
                                        (_maybe-set-cdr!1966_ _a1959_ _b1961_)
                                        _endb1962_)
                                      (let ((_next-a1996_ (cdr _a1959_)))
                                        (_scan-a1964_
                                         _a1959_
                                         (car _next-a1996_)
                                         _next-a1996_
                                         _y1992_
                                         _b1961_)))))))))
               (_grow1914_
                (lambda (_s1929_
                         _ends1930_
                         _ls1931_
                         _ls21932_
                         _u1933_
                         _lw1934_)
                  (if (and (pair? _u1933_) (< _ls1931_ _lw1934_))
                      (let ((_ls21942_
                             (let _lp1936_ ((_ls21938_ _ls21932_))
                               (let ((_ls2*21940_ (+ _ls21938_ _ls21938_)))
                                 (if (<= _ls2*21940_ _ls1931_)
                                     (_lp1936_ _ls2*21940_)
                                     _ls21938_)))))
                        (call-with-values
                         (lambda () (_getrun1912_ _u1933_))
                         (lambda (_lr1945_ _endr1946_ _u21947_)
                           (call-with-values
                            (lambda ()
                              (_grow1914_
                               _u1933_
                               _endr1946_
                               _lr1945_
                               '1
                               _u21947_
                               _ls21942_))
                            (lambda (_t1950_ _endt1951_ _lt1952_ _u31953_)
                              (call-with-values
                               (lambda ()
                                 (_merge!1913_
                                  _s1929_
                                  _ends1930_
                                  _t1950_
                                  _endt1951_))
                               (lambda (_st1956_ _end-st1957_)
                                 (_grow1914_
                                  _st1956_
                                  _end-st1957_
                                  (+ _ls1931_ _lt1952_)
                                  (+ _ls21942_ _ls21942_)
                                  _u31953_
                                  _lw1934_))))))))
                      (values _s1929_ _ends1930_ _ls1931_ _u1933_)))))
        (if (pair? _lis1909_)
            (call-with-values
             (lambda () (_getrun1912_ _lis1909_))
             (lambda (_lr1917_ _endr1918_ _rest1919_)
               (let ((_infinity1921_ '16777216))
                 (call-with-values
                  (lambda ()
                    (_grow1914_
                     _lis1909_
                     _endr1918_
                     _lr1917_
                     '1
                     _rest1919_
                     _infinity1921_))
                  (lambda (_a1924_ _enda1925_ _la1926_ _v1927_)
                    (set-cdr! _enda1925_ '())
                    _a1924_)))))
            '()))))
  (define std/sort#really-heap-sort!
    (lambda (_v1859_ _elt<1860_ _start1861_ _end1862_)
      (letrec ((_restore-heap!1864_
                (lambda (_end1880_ _i1881_)
                  (let* ((_vi1883_ (vector-ref _v1859_ _i1881_))
                         (_first-leaf1885_
                          (quotient (+ _start1861_ _end1880_) '2))
                         (_final-k1906_
                          (let _lp1887_ ((_k1889_ _i1881_))
                            (if (>= _k1889_ _first-leaf1885_)
                                _k1889_
                                (let* ((_k*2-start1891_
                                        (+ _k1889_ (- _k1889_ _start1861_)))
                                       (_child11893_ (+ '1 _k*2-start1891_))
                                       (_child21895_ (+ '2 _k*2-start1891_))
                                       (_child1-val1897_
                                        (vector-ref _v1859_ _child11893_)))
                                  (call-with-values
                                   (lambda ()
                                     (if (< _child21895_ _end1880_)
                                         (let ((_child2-val1901_
                                                (vector-ref
                                                 _v1859_
                                                 _child21895_)))
                                           (if (_elt<1860_
                                                _child2-val1901_
                                                _child1-val1897_)
                                               (values _child11893_
                                                       _child1-val1897_)
                                               (values _child21895_
                                                       _child2-val1901_)))
                                         (values _child11893_
                                                 _child1-val1897_)))
                                   (lambda (_max-child1903_
                                            _max-child-val1904_)
                                     (if (_elt<1860_
                                          _vi1883_
                                          _max-child-val1904_)
                                         (begin
                                           (vector-set!
                                            _v1859_
                                            _k1889_
                                            _max-child-val1904_)
                                           (_lp1887_ _max-child1903_))
                                         _k1889_))))))))
                    (vector-set! _v1859_ _final-k1906_ _vi1883_)))))
        (let ((_first-leaf1866_ (quotient (+ _start1861_ _end1862_) '2)))
          (let _$loop1868_ ((_i1871_ (- _first-leaf1866_ '1)))
            (if (< _i1871_ '0)
                '#!void
                (begin
                  (_restore-heap!1864_ _end1862_ _i1871_)
                  (_$loop1868_ (- _i1871_ '1))))))
        (let _$loop1873_ ((_i1876_ (- _end1862_ '1)))
          (if (<= _i1876_ '0)
              '#!void
              (begin
                (let ((_top1878_ (vector-ref _v1859_ _start1861_)))
                  (vector-set!
                   _v1859_
                   _start1861_
                   (vector-ref _v1859_ _i1876_))
                  (vector-set! _v1859_ _i1876_ _top1878_)
                  (_restore-heap!1864_ _i1876_ _start1861_))
                (_$loop1873_ (- _i1876_ '1))))))))
  (define std/sort#heap-sort!
    (lambda (_v1851_ _elt<1852_ . _maybe-start+end1853_)
      (call-with-values
       (lambda ()
         (std/sort#parse-vector-final-start+end
          std/sort#heap-sort!
          _v1851_
          _maybe-start+end1853_))
       (lambda (_start1856_ _end1857_)
         (std/sort#really-heap-sort!
          _v1851_
          _elt<1852_
          _start1856_
          _end1857_)))))
  (define std/sort#heap-sort
    (lambda (_v1841_ _elt<1842_ . _maybe-start+end1843_)
      (call-with-values
       (lambda ()
         (std/sort#parse-vector-final-start+end
          std/sort#heap-sort
          _v1841_
          _maybe-start+end1843_))
       (lambda (_start1846_ _end1847_)
         (let ((_ans1849_ (subvector _v1841_ _start1846_ _end1847_)))
           (std/sort#really-heap-sort!
            _ans1849_
            _elt<1842_
            '0
            (- _end1847_ _start1846_))
           _ans1849_)))))
  (define std/sort#%vector-merge!
    (lambda (_v1803_
             _v11804_
             _v21805_
             _elt<1806_
             _start01807_
             _start11808_
             _end11809_
             _start21810_
             _end21811_)
      (letrec ((_vblit1813_
                (lambda (_fromv1815_ _j1816_ _i1817_ _end1818_)
                  (let _lp1820_ ((_j1822_ _j1816_) (_i1823_ _i1817_))
                    (vector-set!
                     _v1803_
                     _i1823_
                     (vector-ref _fromv1815_ _j1822_))
                    (let ((_j1825_ (+ _j1822_ '1)))
                      (if (< _j1825_ _end1818_)
                          (_lp1820_ _j1825_ (+ _i1823_ '1))
                          '#!void))))))
        (if (<= _end11809_ _start11808_)
            (if (< _start21810_ _end21811_)
                (_vblit1813_ _v21805_ _start21810_ _start01807_ _end21811_)
                '#!void)
            (if (<= _end21811_ _start21810_)
                (_vblit1813_ _v11804_ _start11808_ _start01807_ _end11809_)
                (let _lp1827_ ((_i1829_ _start01807_)
                               (_j1830_ _start11808_)
                               (_x1831_ (vector-ref _v11804_ _start11808_))
                               (_k1832_ _start21810_)
                               (_y1833_ (vector-ref _v21805_ _start21810_)))
                  (let ((_i11835_ (+ _i1829_ '1)))
                    (if (_elt<1806_ _y1833_ _x1831_)
                        (let ((_k1837_ (+ _k1832_ '1)))
                          (vector-set! _v1803_ _i1829_ _y1833_)
                          (if (< _k1837_ _end21811_)
                              (_lp1827_
                               _i11835_
                               _j1830_
                               _x1831_
                               _k1837_
                               (vector-ref _v21805_ _k1837_))
                              (_vblit1813_
                               _v11804_
                               _j1830_
                               _i11835_
                               _end11809_)))
                        (let ((_j1839_ (+ _j1830_ '1)))
                          (vector-set! _v1803_ _i1829_ _x1831_)
                          (if (< _j1839_ _end11809_)
                              (_vblit1813_
                               _v21805_
                               _k1832_
                               _i11835_
                               _end21811_)
                              (_lp1827_
                               _i11835_
                               _j1839_
                               (vector-ref _v11804_ _j1839_)
                               _k1832_
                               _y1833_)))))))))))
  (define std/sort#%vector-merge-sort!
    (lambda (_v01755_ _elt<1756_ _l1757_ _r1758_ _temp01759_)
      (letrec ((_xor1761_
                (lambda (_a1800_ _b1801_) (not (eq? _a1800_ _b1801_)))))
        (if (< _l1757_ _r1758_)
            (call-with-values
             (lambda ()
               (let _recur1764_ ((_l1766_ _l1757_)
                                 (_want1767_ (- _r1758_ _l1757_)))
                 (let ((_len1769_ (- _r1758_ _l1766_)))
                   (let _lp1771_ ((_pfxlen1773_
                                   (std/sort#getrun
                                    _v01755_
                                    _l1766_
                                    _r1758_
                                    _elt<1756_))
                                  (_pfxlen21774_ '1)
                                  (_v1775_ _v01755_)
                                  (_temp1776_ _temp01759_)
                                  (_v=v0?1777_ '#t))
                     (if (or (>= _pfxlen1773_ _want1767_)
                             (= _pfxlen1773_ _len1769_))
                         (values _pfxlen1773_ _v1775_ _v=v0?1777_)
                         (let ((_pfxlen21788_
                                (let _lp1782_ ((_j1784_ _pfxlen21774_))
                                  (let ((_j*21786_ (+ _j1784_ _j1784_)))
                                    (if (<= _j1784_ _pfxlen1773_)
                                        (_lp1782_ _j*21786_)
                                        _j1784_))))
                               (_tail-len1789_ (- _len1769_ _pfxlen1773_)))
                           (call-with-values
                            (lambda ()
                              (_recur1764_
                               (+ _pfxlen1773_ _l1766_)
                               _pfxlen21788_))
                            (lambda (_nr-len1792_ _nr-vec1793_ _nrvec=v0?1794_)
                              (std/sort#%vmerge
                               _temp1776_
                               _v1775_
                               _nr-vec1793_
                               _l1766_
                               _pfxlen1773_
                               _nr-len1792_
                               (_xor1761_ _nrvec=v0?1794_ _v=v0?1777_)
                               _elt<1756_)
                              (_lp1771_
                               (+ _pfxlen1773_ _nr-len1792_)
                               (+ _pfxlen21788_ _pfxlen21788_)
                               _temp1776_
                               _v1775_
                               (not _v=v0?1777_))))))))))
             (lambda (_ignored-len1796_ _ignored-ansvec1797_ _ansvec=v0?1798_)
               (if (not _ansvec=v0?1798_)
                   (std/sort#vector-copy! _v01755_ _temp01759_ _l1757_ _r1758_)
                   '#!void)))
            '#!void))))
  (define std/sort#%vmerge
    (lambda (_target1713_
             _v11714_
             _v21715_
             _l1716_
             _len11717_
             _len21718_
             _v2=target?1719_
             _elt<1720_)
      (letrec ((_vblit1722_
                (lambda (_fromv1724_ _j1725_ _i1726_ _end1727_)
                  (let _lp1729_ ((_j1731_ _j1725_) (_i1732_ _i1726_))
                    (vector-set!
                     _target1713_
                     _i1732_
                     (vector-ref _fromv1724_ _j1731_))
                    (let ((_j1734_ (+ _j1731_ '1)))
                      (if (< _j1734_ _end1727_)
                          (_lp1729_ _j1734_ (+ _i1732_ '1))
                          '#!void))))))
        (let* ((_r11736_ (+ _l1716_ _len11717_))
               (_r21738_ (+ _r11736_ _len21718_)))
          (let _lp1741_ ((_i1743_ _l1716_)
                         (_j1744_ _l1716_)
                         (_x1745_ (vector-ref _v11714_ _l1716_))
                         (_k1746_ _r11736_)
                         (_y1747_ (vector-ref _v21715_ _r11736_)))
            (let ((_i11749_ (+ _i1743_ '1)))
              (if (_elt<1720_ _y1747_ _x1745_)
                  (let ((_k1751_ (+ _k1746_ '1)))
                    (vector-set! _target1713_ _i1743_ _y1747_)
                    (if (< _k1751_ _r21738_)
                        (_lp1741_
                         _i11749_
                         _j1744_
                         _x1745_
                         _k1751_
                         (vector-ref _v21715_ _k1751_))
                        (_vblit1722_ _v11714_ _j1744_ _i11749_ _r11736_)))
                  (let ((_j1753_ (+ _j1744_ '1)))
                    (vector-set! _target1713_ _i1743_ _x1745_)
                    (if (< _j1753_ _r11736_)
                        (_lp1741_
                         _i11749_
                         _j1753_
                         (vector-ref _v11714_ _j1753_)
                         _k1746_
                         _y1747_)
                        (if (not _v2=target?1719_)
                            (_vblit1722_ _v21715_ _k1746_ _i11749_ _r21738_)
                            '#!void))))))))))
  (define std/sort#getrun
    (lambda (_v1701_ _l1702_ _r1703_ _elt<1704_)
      (let _lp1706_ ((_i1708_ (+ _l1702_ '1))
                     (_x1709_ (vector-ref _v1701_ _l1702_)))
        (if (>= _i1708_ _r1703_)
            (- _i1708_ _l1702_)
            (let ((_y1711_ (vector-ref _v1701_ _i1708_)))
              (if (_elt<1704_ _y1711_ _x1709_)
                  (- _i1708_ _l1702_)
                  (_lp1706_ (+ _i1708_ '1) _y1711_)))))))
  (define std/sort#list-sorted?
    (lambda (_list1685_ _<1686_)
      (let ((_$e1688_ (not (pair? _list1685_))))
        (if _$e1688_
            _$e1688_
            (let _lp1691_ ((_prev1693_ (car _list1685_))
                           (_tail1694_ (cdr _list1685_)))
              (let ((_$e1696_ (not (pair? _tail1694_))))
                (if _$e1696_
                    _$e1696_
                    (let ((_next1699_ (car _tail1694_)))
                      (if (not (_<1686_ _next1699_ _prev1693_))
                          (_lp1691_ _next1699_ (cdr _tail1694_))
                          '#f)))))))))
  (define std/sort#vector-sorted?
    (lambda (_v1664_ _elt<1665_ . _maybe-start+end1666_)
      (if (vector? _v1664_) '#!void (error '"Expected vector" _v1664_))
      (call-with-values
       (lambda ()
         (std/sort#parse-vector-final-start+end
          std/sort#vector-sorted?
          _v1664_
          _maybe-start+end1666_))
       (lambda (_start1669_ _end1670_)
         (let ((_$e1672_ (>= _start1669_ _end1670_)))
           (if _$e1672_
               _$e1672_
               (let _lp1675_ ((_i1677_ (+ _start1669_ '1))
                              (_vi-11678_ (vector-ref _v1664_ _start1669_)))
                 (let ((_$e1680_ (>= _i1677_ _end1670_)))
                   (if _$e1680_
                       _$e1680_
                       (let ((_vi1683_ (vector-ref _v1664_ _i1677_)))
                         (if (not (_elt<1665_ _vi1683_ _vi-11678_))
                             (_lp1675_ (+ _i1677_ '1) _vi1683_)
                             '#f))))))))))))
